#include "HAL_conf.h"
#include "HAL_device.h"
#include "stdio.h"

void LED_Init(void);
void delay_init(void);
void delay_ms(u16 nms);

/*usʱ*/		
static u8  fac_us=0; 
/*msʱ,ucos,ÿĵms*/
static u16 fac_ms=0; 

#define LED4_OFF()  GPIO_SetBits(GPIOB,GPIO_Pin_5)	
#define LED4_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOB,GPIO_Pin_5))?(GPIO_ResetBits(GPIOB,GPIO_Pin_5)):(GPIO_SetBits(GPIOB,GPIO_Pin_5))	

#define LED3_OFF()  GPIO_SetBits(GPIOB,GPIO_Pin_4)	
#define LED3_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOB,GPIO_Pin_4))?(GPIO_ResetBits(GPIOB,GPIO_Pin_4)):(GPIO_SetBits(GPIOB,GPIO_Pin_4))	
	
#define LED1_OFF()  GPIO_SetBits(GPIOA,GPIO_Pin_15)	
#define LED1_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOA,GPIO_Pin_15))?(GPIO_ResetBits(GPIOA,GPIO_Pin_15)):(GPIO_SetBits(GPIOA,GPIO_Pin_15))

/********************************************************************************************************
**Ϣ main(void)                     
** 
** 
** 
********************************************************************************************************/
int main(void)    
{
	delay_init();
    LED_Init();
    while(1)            
    {
        LED1_TOGGLE();
        LED3_TOGGLE();
        LED4_TOGGLE();
        delay_ms(1000);
    }
}


/********************************************************************************************************
**Ϣ LED_Init(void)                        
** LEDʼ
** 
** 
********************************************************************************************************/
void LED_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;

    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA|RCC_AHB1Periph_GPIOB, ENABLE);  
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    
    GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_4|GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    LED1_OFF();
    LED3_OFF();
    LED4_OFF();
}

/********************************************************************************************************
**Ϣ void delay_init(void)                         
** ʼӳٺ
** 
** 
**ú 
********************************************************************************************************/
void delay_init(void)
{
    /*ѡⲿʱ  HCLK/8*/
    SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);
    /*Ϊϵͳʱӵ1/8*/    
    fac_us=SystemCoreClock/8000000;				                               
    /*OS,ÿmsҪsystickʱ */
    fac_ms=(u16)fac_us*1000;					                              
}


/********************************************************************************************************
**Ϣ void delay_ms(u16 nms)    
** ʱnms
** nms
** 
**    ע SysTick->LOADΪ24λĴ,,ʱΪ:nms<=0xffffff*8*1000/SYSCLK,72M,nms<=1864 
********************************************************************************************************/
void delay_ms(u16 nms)
{
    u32 temp;
    /*ʱ(SysTick->LOADΪ24bit)*/    
    SysTick->LOAD=(u32)nms*fac_ms;
    /*ռ*/    
    SysTick->VAL =0x00;	
    /*ʼ*/    
    SysTick->CTRL|=SysTick_CTRL_ENABLE_Msk ;	                               
    do{
        temp=SysTick->CTRL;
    }
    /*ȴʱ䵽*/
    while((temp&0x01)&&!(temp&(1<<16)));		                            
    /*رռ*/
    SysTick->CTRL&=~SysTick_CTRL_ENABLE_Msk;	                           
    /*ռ*/    
    SysTick->VAL =0X00;       					                               
}
