#include "HAL_conf.h"
#include "HAL_device.h"
#include "stdio.h"

/*usʱ*/		
static u8  fac_us=0; 
/*msʱ,ucos,ÿĵms*/
static u16 fac_ms=0;
char printBuf[100];

void delay_init(void);
void delay_ms(u16 nms);
void UartSendGroup(u8* buf,u16 len);
void uart_initwBaudRate(u32 bound);
void LED_Init(void);
u8 FLASH_Program(void);

#define LED4_ON()  GPIO_ResetBits(GPIOB,GPIO_Pin_5)	
#define LED4_OFF()  GPIO_SetBits(GPIOB,GPIO_Pin_5)	
#define LED4_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOB,GPIO_Pin_5))?(GPIO_ResetBits(GPIOB,GPIO_Pin_5)):(GPIO_SetBits(GPIOB,GPIO_Pin_5))	

#define LED3_ON()  GPIO_ResetBits(GPIOB,GPIO_Pin_4)	
#define LED3_OFF()  GPIO_SetBits(GPIOB,GPIO_Pin_4)	
#define LED3_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOB,GPIO_Pin_4))?(GPIO_ResetBits(GPIOB,GPIO_Pin_4)):(GPIO_SetBits(GPIOB,GPIO_Pin_4))	

#define LED1_ON()  GPIO_ResetBits(GPIOA,GPIO_Pin_15)	
#define LED1_OFF()  GPIO_SetBits(GPIOA,GPIO_Pin_15)	
#define LED1_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOA,GPIO_Pin_15))?(GPIO_ResetBits(GPIOA,GPIO_Pin_15)):(GPIO_SetBits(GPIOA,GPIO_Pin_15))

#define FLASH_PAGE_SIZE    ((uint16_t)0x400)
#define BANK1_WRITE_START_ADDR  ((uint32_t)0x08002800)
#define BANK1_WRITE_END_ADDR    ((uint32_t)0x08003200)
uint32_t Data = 0x12345679;
volatile FLASH_Status FLASHStatus = FLASH_COMPLETE;

/********************************************************************************************************
**Ϣ main(void)                     
** 
** 
** 
**    ע سǰҪѡȫ
********************************************************************************************************/
int main(void)    
{ 
    u8 t; 
    delay_init();
    LED_Init();
    uart_initwBaudRate(9600);
    t=FLASH_Program();
    
    if(t==0)
        while(1)              
        {
            UartSendGroup((u8*)printBuf, sprintf(printBuf,"program ok\r\n"));
            LED1_TOGGLE();
            LED3_TOGGLE();
            LED4_TOGGLE();
            delay_ms(1000);
        }
    else
        while(1)
        {
            UartSendGroup((u8*)printBuf, sprintf(printBuf,"program error\r\n"));
            delay_ms(1000);
        }
}

/********************************************************************************************************
**Ϣ void uart_initwBaudRate(u32 bound)     
** UARTʼ
** bound
** 
**    ע 
********************************************************************************************************/
void uart_initwBaudRate(u32 bound)
{
    /*GPIO˿*/
    GPIO_InitTypeDef GPIO_InitStructure;
    UART_InitTypeDef UART_InitStructure;
    
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
    
    /*UART1_TX   GPIOA.9*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;                                   
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    /**/    
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;		                     
    GPIO_Init(GPIOA, &GPIO_InitStructure);				                        
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_7);
    
    /*UART1_RX  GPIOA.10ʼ*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	                 
    GPIO_Init(GPIOA, &GPIO_InitStructure);				                     
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_7);
    
    /*UART ʼ*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_UART1, ENABLE);	                   

    /*ڲ*/
    UART_InitStructure.UART_BaudRate = bound;
    /*ֳΪ8λݸʽ*/    
    UART_InitStructure.UART_WordLength = UART_WordLength_8b;
    /*һֹͣλ*/    
    UART_InitStructure.UART_StopBits = UART_StopBits_1;
    /*żУλ*/    
    UART_InitStructure.UART_Parity = UART_Parity_No;
    /*Ӳ*/    
    UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None;
    /*շģʽ*/
    UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx;	                
    /*ʼ1*/
    UART_Init(UART1, &UART_InitStructure); 	
    /*ڽж*/    
    UART_ITConfig(UART1, UART_IT_RXIEN, ENABLE);
    /*ʹܴ1*/    
    UART_Cmd(UART1, ENABLE);                    			                    
}

/********************************************************************************************************
**Ϣ u8 FLASH_Program(void)    
** Program FLASH Bank1
** 
** 
**    ע 
********************************************************************************************************/
u8 FLASH_Program(void)
{
         
    /* Unlock the Flash Bank1 Program Erase controller */
    FLASH_Unlock();
    
    /* Clear All pending flags */
    FLASH_ClearFlag(FLASH_FLAG_EOP | FLASH_FLAG_PGERR | FLASH_FLAG_WRPRTERR);	
    
    FLASH_ErasePage(BANK1_WRITE_START_ADDR);
    
    FLASH_ClearFlag(FLASH_FLAG_EOP );	
    
    FLASHStatus = FLASH_ProgramWord(0x08001FFC, Data);
    
    FLASH_ClearFlag(FLASH_FLAG_EOP );	
    
    FLASH_Lock();
    
	UartSendGroup((u8*)printBuf, sprintf(printBuf,"%x\r\n",(*(__IO uint32_t*) 0x08001FFC)));
    
    if((*(__IO uint32_t*) 0x08001FFC) != Data)
    {
        return 1;
    }
    return 0;
}

/********************************************************************************************************
**Ϣ void delay_init(void)                         
** ʼӳٺ
** 
** 
**ú 
********************************************************************************************************/
void delay_init(void)
{
    /*ѡⲿʱ  HCLK/8*/
    SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);
    /*Ϊϵͳʱӵ1/8*/    
    fac_us=SystemCoreClock/8000000;				                               
    /*OS,ÿmsҪsystickʱ */
    fac_ms=(u16)fac_us*1000;					                              
}


/********************************************************************************************************
**Ϣ void delay_ms(u16 nms)    
** ʱnms
** nms
** 
**    ע SysTick->LOADΪ24λĴ,,ʱΪ:nms<=0xffffff*8*1000/SYSCLK,72M,nms<=1864 
********************************************************************************************************/
void delay_ms(u16 nms)
{
    u32 temp;
    /*ʱ(SysTick->LOADΪ24bit)*/    
    SysTick->LOAD=(u32)nms*fac_ms;
    /*ռ*/    
    SysTick->VAL =0x00;	
    /*ʼ*/    
    SysTick->CTRL|=SysTick_CTRL_ENABLE_Msk ;	                               
    do{
        temp=SysTick->CTRL;
    }
    /*ȴʱ䵽*/
    while((temp&0x01)&&!(temp&(1<<16)));		                            
    /*رռ*/
    SysTick->CTRL&=~SysTick_CTRL_ENABLE_Msk;	                           
    /*ռ*/    
    SysTick->VAL =0X00;       					                               
}

/********************************************************************************************************
**Ϣ LED_Init(void)                        
** LEDʼ
** 
** 
********************************************************************************************************/
void LED_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;

    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA|RCC_AHB1Periph_GPIOB, ENABLE); 
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    
    GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_4|GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    LED1_OFF();
    LED3_OFF();
    LED4_OFF();
}


/********************************************************************************************************
**Ϣ void UartSendByte(u8 dat)      
** UART
** dat
** 
**    ע 
********************************************************************************************************/
void UartSendByte(u8 dat)
{
    UART_SendData( UART1, dat);
    while(!UART_GetFlagStatus(UART1,UART_FLAG_TXEPT));
}


/********************************************************************************************************
**Ϣ void UartSendGroup(u8* buf,u16 len)     
** UART
** buf,len
** 
**    ע 
********************************************************************************************************/
void UartSendGroup(u8* buf,u16 len)
{
    while(len--)
        UartSendByte(*buf++);
}
