#include "HAL_conf.h"
#include "HAL_device.h"
#include "stdio.h"

/*usʱ*/		
static u8  fac_us=0; 
/*msʱ,ucos,ÿĵms*/
static u16 fac_ms=0; 
char printBuf[100];

void delay_init(void);
void uart_initwBaudRate(u32 bound);
void delay_ms(u16 nms);
void UartSendGroup(u8* buf,u16 len);
void LED_Init(void);
void WKUP_Init(void);
u8 Check_WKUP(void);
void Sys_Standby(void);

#define LED4_ON()  GPIO_ResetBits(GPIOB,GPIO_Pin_5)	
#define LED4_OFF()  GPIO_SetBits(GPIOB,GPIO_Pin_5)	
#define LED4_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOB,GPIO_Pin_5))?(GPIO_ResetBits(GPIOB,GPIO_Pin_5)):(GPIO_SetBits(GPIOB,GPIO_Pin_5))	

#define LED3_ON()  GPIO_ResetBits(GPIOB,GPIO_Pin_4)	
#define LED3_OFF()  GPIO_SetBits(GPIOB,GPIO_Pin_4)	
#define LED3_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOB,GPIO_Pin_4))?(GPIO_ResetBits(GPIOB,GPIO_Pin_4)):(GPIO_SetBits(GPIOB,GPIO_Pin_4))	

#define LED1_ON()  GPIO_ResetBits(GPIOA,GPIO_Pin_15)	
#define LED1_OFF()  GPIO_SetBits(GPIOA,GPIO_Pin_15)	
#define LED1_TOGGLE()  (GPIO_ReadOutputDataBit(GPIOA,GPIO_Pin_15))?(GPIO_ResetBits(GPIOA,GPIO_Pin_15)):(GPIO_SetBits(GPIOA,GPIO_Pin_15))

/********************************************************************************************************
**Ϣ int main (void)                          
** 󣬽PA0GND̽
** 
** 
********************************************************************************************************/
int main(void)
{ 
    /*ʱʼ*/
    delay_init();	    
    /*жȼ2*/    
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);	
    /*ڳʼΪ9600*/    
    uart_initwBaudRate(9600);	 						                        
    UartSendGroup((u8*)printBuf, sprintf(printBuf,"밴wake up3벻\r\n"));
    /*ʼLEDӵӲӿ*/
    LED_Init();		  									                        
    /*ʼWK_UPͬʱǷ*/
    WKUP_Init();										                        
    while(1)                                                                    
    {                                                                           
        LED1_TOGGLE();                                                          
        LED3_TOGGLE();                                                          
        LED4_TOGGLE();
        /*ʱ250ms*/        
        delay_ms(250);									                        
        UartSendGroup((u8*)printBuf, sprintf(printBuf,"Ѵstandbyģʽ\r\n"));
    }											    
}	

/********************************************************************************************************
**Ϣ void delay_init(void)                         
** ʼӳٺ
** 
** 
**ú 
********************************************************************************************************/
void delay_init(void)
{
    /*ѡⲿʱ  HCLK/8*/
    SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);
    /*Ϊϵͳʱӵ1/8*/    
    fac_us=SystemCoreClock/8000000;				                               
    /*OS,ÿmsҪsystickʱ */
    fac_ms=(u16)fac_us*1000;					                              
}


/********************************************************************************************************
**Ϣ void delay_ms(u16 nms)    
** ʱnms
** nms
** 
**    ע SysTick->LOADΪ24λĴ,,ʱΪ:nms<=0xffffff*8*1000/SYSCLK,72M,nms<=1864 
********************************************************************************************************/
void delay_ms(u16 nms)
{
    u32 temp;
    /*ʱ(SysTick->LOADΪ24bit)*/    
    SysTick->LOAD=(u32)nms*fac_ms;
    /*ռ*/    
    SysTick->VAL =0x00;	
    /*ʼ*/    
    SysTick->CTRL|=SysTick_CTRL_ENABLE_Msk ;	                               
    do{
        temp=SysTick->CTRL;
    }
    /*ȴʱ䵽*/
    while((temp&0x01)&&!(temp&(1<<16)));		                            
    /*رռ*/
    SysTick->CTRL&=~SysTick_CTRL_ENABLE_Msk;	                           
    /*ռ*/    
    SysTick->VAL =0X00;       					                               
}

/********************************************************************************************************
**Ϣ void uart_initwBaudRate(u32 bound)     
** UARTʼ
** bound
** 
**    ע 
********************************************************************************************************/
void uart_initwBaudRate(u32 bound)
{
    /*GPIO˿*/
    GPIO_InitTypeDef GPIO_InitStructure;
    UART_InitTypeDef UART_InitStructure;
    
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
    
    /*UART1_TX   GPIOA.9*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;                                   
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    /**/    
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;		                     
    GPIO_Init(GPIOA, &GPIO_InitStructure);				                        
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_7);
    
    /*UART1_RX  GPIOA.10ʼ*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	                 
    GPIO_Init(GPIOA, &GPIO_InitStructure);				                     
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_7);
    
    /*UART ʼ*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_UART1, ENABLE);	                   

    /*ڲ*/
    UART_InitStructure.UART_BaudRate = bound;
    /*ֳΪ8λݸʽ*/    
    UART_InitStructure.UART_WordLength = UART_WordLength_8b;
    /*һֹͣλ*/    
    UART_InitStructure.UART_StopBits = UART_StopBits_1;
    /*żУλ*/    
    UART_InitStructure.UART_Parity = UART_Parity_No;
    /*Ӳ*/    
    UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None;
    /*շģʽ*/
    UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx;	                
    /*ʼ1*/
    UART_Init(UART1, &UART_InitStructure); 	
    /*ڽж*/    
    UART_ITConfig(UART1, UART_IT_RXIEN, ENABLE);
    /*ʹܴ1*/    
    UART_Cmd(UART1, ENABLE);                    			                    
}

/********************************************************************************************************
**Ϣ LED_Init(void)                        
** LEDʼ
** 
** 
********************************************************************************************************/
void LED_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;

    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA|RCC_AHB1Periph_GPIOB, ENABLE);  
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    
    GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_4|GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    LED1_OFF();
    LED3_OFF();
    LED4_OFF();
}

/********************************************************************************************************
**Ϣ WKUP_Init(void)                         
** ⲿжϻѴʼ
** 
** 
********************************************************************************************************/
void WKUP_Init(void)
{	
    GPIO_InitTypeDef  GPIO_InitStructure;  		  
    NVIC_InitTypeDef NVIC_InitStructure;
    EXTI_InitTypeDef EXTI_InitStructure;
    
    /*ʹGPIOAʱ*/
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);					    
        
    /*PA.0*/    
    GPIO_InitStructure.GPIO_Pin =GPIO_Pin_0;	
    /**/    
    GPIO_InitStructure.GPIO_Mode =GPIO_Mode_IPD;							    
    GPIO_Init(GPIOA, &GPIO_InitStructure);									  
    /*ʹⲿжϷʽ*/  
    /*ж0GPIOA.0*/    
    SYSCFG_EXTILineConfig(GPIO_PortSourceGPIOA, GPIO_PinSource0);			    
             
    /*ðеⲿ·*/    
    EXTI_InitStructure.EXTI_Line = EXTI_Line0;
    /*ⲿжģʽ:EXTI·Ϊж*/    
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;	
    /*ش*/    
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;  				    
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;
    /* ʼⲿж*/    
    EXTI_Init(&EXTI_InitStructure);											    
                     
    /*ʹܰڵⲿжͨ*/                     
    NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQn; 
    /*ռȼ2*/    
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2; 
    /*ȼ2*/    
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2; 		
    /*ʹⲿжͨ*/    
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; 
    /*NVIC_InitStructָĲʼNVICĴ*/    
    NVIC_Init(&NVIC_InitStructure); 										    
                                      
    /*ǿ,ģʽ*/                                      
    if(Check_WKUP()==0) Sys_Standby();    									    
}

/********************************************************************************************************
**Ϣ Check_WKUP(void)                         
** жϰǷ
** 
** 
********************************************************************************************************/
u8 Check_WKUP(void) 
{
    /*¼µʱ*/
    u8 t=0;	
    LED1_ON();
    LED3_ON();
    LED4_ON();
    while(1)
    {
        if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0))
        {
            /*Ѿ*/
            t++;					                                             
            delay_ms(30); 
            /*³3*/            
            if(t>=100)				                                            
            {                                                                   
                LED1_ON();                                                      
                LED3_ON();                                                      
                LED4_ON();  
                /*3s*/                
                return 1; 			                                            
            }                                                                   
        }else                                                                   
        {                                                                       
            LED1_OFF();                                                         
            LED3_OFF();                                                         
            LED4_OFF();  
            /*²3*/            
            return 0; 				                                            
        }                                                                       
    }
} 

/********************************************************************************************************
**Ϣ Sys_Standby(void)                         
** ģʽ
** 
** 
********************************************************************************************************/
void Sys_Standby(void)
{  
    /*ʹPWRʱ*/
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);	 
    /*λIO*/    
    RCC->APB2RSTR|=0X01FC;
    /*ʹܻѹܽŹ*/    
    PWR_WakeUpPinCmd(ENABLE);  
    /*STANDBYģʽ*/    
    PWR_EnterSTANDBYMode();	  							                        
    
}

/********************************************************************************************************
**Ϣ void UartSendByte(u8 dat)      
** UART
** dat
** 
**    ע 
********************************************************************************************************/
void UartSendByte(u8 dat)
{
    UART_SendData( UART1, dat);
    while(!UART_GetFlagStatus(UART1,UART_FLAG_TXEPT));
}


/********************************************************************************************************
**Ϣ void UartSendGroup(u8* buf,u16 len)     
** UART
** buf,len
** 
**    ע 
********************************************************************************************************/
void UartSendGroup(u8* buf,u16 len)
{
    while(len--)
        UartSendByte(*buf++);
}

