#include "HAL_conf.h"
#include "HAL_device.h"
#include "stdio.h"

void HSE_Pll_test(unsigned int pllmul);

/********************************************************************************************************
**Ϣ int main (void)                          
** ARMLED
** 
** 
********************************************************************************************************/
int main(void)
{
    /*ѡⲿʱԴΪƵʱӵĻ*/
    HSE_Pll_test(RCC_PLLMul_12);                                                
    
    while(1)              		
    {       
    }
}


/********************************************************************************************************
**Ϣ SystemClk_HSEInit (void)                        
** ϵͳʱӳʼʼ֮ǰȸλʱ
** 
** 
********************************************************************************************************/
void SystemClk_HSEInit(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); 
    
    /*mco  pa8*/
    GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_8;   		                        
    GPIO_InitStructure.GPIO_Speed =  GPIO_Speed_10MHz;
    /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 	                        
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource8, GPIO_AF_0);
    
    RCC_DeInit();
    /*CRĴBIT16λHSEONλ1ⲿʱHSEΪϵͳʱ*/
    RCC_HSEConfig(RCC_HSE_ON);
    while(1){
        if(RCC_WaitForHSEStartUp()!=0)
        {
            break;
        }
    }
    
    /*ѡⲿʱΪϵͳʱ*/
    RCC_SYSCLKConfig(RCC_SYSCLKSource_HSE);	
    /*ͨPA8 pin ۲Ƶ*/    
    RCC_MCOConfig(RCC_MCO_SYSCLK);  					                        
}


/********************************************************************************************************
**Ϣ SystemClkPll(unsigned int pllmul)                
** ƵƵΪϵͳʱ
** ƵѡRCC_PLLMul_2  RCC_PLLMul_16 
** 
********************************************************************************************************/
void SystemClkPll(unsigned int pllmul)
{
    /*ʹPLL*/
    RCC_PLLCmd(ENABLE); 				                                        
    
    while(1){
        /*ѯPLL ready*/
        if(RCC->CR&0x02000000) 				                                    
        {
            break;
        }
    }
    
    /*ʱӵȴ״̬*/
    FLASH_SetLatency(FLASH_Latency_2);			                                 
   
    /*ͨPA8 pin ۲Ƶ*/    
    RCC_MCOConfig(RCC_MCO_PLLCLK_Div2);  	
    /*ѡPLLʱΪϵͳʱ*/    
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);	                            	
}


/********************************************************************************************************
**Ϣ HSE_Pll_test(unsigned int pllmul)                      
** ⲿΪʱԴ
** ƵѡRCC_PLLMul_2  RCC_PLLMul_16 
** 
********************************************************************************************************/
void HSE_Pll_test(unsigned int pllmul)
{
    SystemClk_HSEInit();
    /*ѡⲿʱԴΪƵʱӵĻ*/
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, pllmul);                              
    SystemClkPll(pllmul);
}


/********************************************************************************************************
**Ϣ LSE_clk()                      
** ڲƵʱӲͨʾ۲PA8 pin 32.786KHz
** 
** 
********************************************************************************************************/
void LSE_clk()
{   
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); 
    
    /*mco  pa8*/
    GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_8;   			                    
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		                    
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource8, GPIO_AF_0);
        
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_BKP, ENABLE);
    
    /*ʹPWR_CRеDBP bit*/
    PWR_BackupAccessCmd(ENABLE); 					                            
                                                                                
    RCC_LSEConfig(RCC_LSE_ON);                                                  
                                                                                
    while(1){       
        /*ѯⲿ32.768KHzƵʱready*/        
        if(RCC->BDCR&0x00000002) 					                            
        {
            break;
        }
    }
    /*ͨPA8 pin ۲Ƶ*/
    RCC_MCOConfig(RCC_MCO_LSE);                                                 
}


/********************************************************************************************************
**Ϣ HSE_HSI_Change()                      
** ⲿʱڲʱ֮л
** 
** 
********************************************************************************************************/
void HSE_HSI_Change()
{
    /*CSS on*/
    RCC_ClockSecuritySystemCmd(ENABLE);                                         
    SystemClk_HSEInit();
    
    /*close HESON*/
    RCC->CR &= 0xfffeffff; 				                                        
}

