#include "HAL_conf.h"
#include "HAL_device.h"
#include "stdio.h"

char printBuf[100];
/*usʱ*/		
static u8  fac_us=0; 
/*msʱ,ucos,ÿĵms*/
static u16 fac_ms=0; 

extern u32 SystemCoreClock;	
void delay_init(void);
void uart_initwBaudRate(u32 bound);
void delay_ms(u16 nms);
void UartSendGroup(u8* buf,u16 len);
void Tim2_UPCount_test(u16 Prescaler,u32 Period);

/********************************************************************************************************
**Ϣ int main (void)                          
** Ҫ32λʱܣһֱӡTIM2 CNTֵ
** void 
** void 
********************************************************************************************************/
unsigned int ucTim2Flag;
u32 getCCRvalue = 0;
u32 getCNTvalue = 0;
  
int main(void)
{
    delay_init();
    uart_initwBaudRate(9600);	 
    /*Test write ARR 32bit*/    
    Tim2_UPCount_test(SystemCoreClock/0x1FFFF,0x1FFFF);  
    /*Test write CCRx 32bit*/    
    TIM_SetCompare1(TIM2, 0x10000);                                             
    getCCRvalue = TIM_GetCapture1(TIM2);                                        
                                                                                
    while(1)                                                                   
    {
        delay_ms(100);
        getCNTvalue = TIM_GetCounter(TIM2);
        UartSendGroup((u8*)printBuf, sprintf(printBuf,"TIM2 Value: 0x%X  \n",getCNTvalue));
    } 
}


/********************************************************************************************************
**Ϣ void TIM2_IRQHandler(void)                  
** ʱ2жϺ
** 
** 
********************************************************************************************************/
void TIM2_IRQHandler(void)
{
    /*ֶжϱ־λ*/
    TIM_ClearITPendingBit(TIM2, TIM_IT_Update);
    
    /*ȫֱ־*/
    ucTim2Flag++;       
}

/********************************************************************************************************
**Ϣ void Tim2_UPCount_test(u16 Prescaler,u32 Period)                 
** öʱ2ϼģʽ
** Period 16λֵ,Prescaler ʱԤƵֵ
** 
********************************************************************************************************/
void Tim2_UPCount_test(u16 Prescaler,u32 Period)
{
    TIM_TimeBaseInitTypeDef TIM_StructInit;
    NVIC_InitTypeDef NVIC_StructInit;
    
    /*ʹTIM1ʱ,ĬʱԴΪPCLK1(PCLK1δƵʱƵ,PCLK1Ƶ),ѡʱԴ*/
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
    
    /*ARRĴֵ*/
    TIM_StructInit.TIM_Period=Period;   
    /*ԤƵֵ*/    
    TIM_StructInit.TIM_Prescaler=Prescaler;                                     
    /*˲Ƶ,Ӱ춨ʱʱ*/  
    /*Ƶֵ*/    
    TIM_StructInit.TIM_ClockDivision=TIM_CKD_DIV1;   
    /*ģʽ*/    
    TIM_StructInit.TIM_CounterMode=TIM_CounterMode_Up;                          
    TIM_StructInit.TIM_RepetitionCounter=0;
    
    TIM_TimeBaseInit(TIM2, &TIM_StructInit);
    
    /*ʱ2ж*/
    TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);
    
    TIM_Cmd(TIM2, ENABLE);	
    
    /*¶ʱʱʱ,־λ*/
    TIM_ClearFlag(TIM2, TIM_FLAG_Update);
    
    /*öʱ2жͨȼ */
    NVIC_StructInit.NVIC_IRQChannel=TIM2_IRQn;
    NVIC_StructInit.NVIC_IRQChannelCmd=ENABLE;
    NVIC_StructInit.NVIC_IRQChannelPreemptionPriority=0;
    NVIC_StructInit.NVIC_IRQChannelSubPriority=1;
    
    NVIC_Init(&NVIC_StructInit);
    
    
}
/********************************************************************************************************
**Ϣ Tim2_UPStatusOVCheck_test(void)                       
** ȴʱ
** 
** 
********************************************************************************************************/
void Tim2_UPStatusOVCheck_test(void)
{
    /*ȴ¼±־λ*/
    while(TIM_GetFlagStatus(TIM2,TIM_FLAG_Update)==RESET);
    /*¼־λ*/
    TIM_ClearFlag(TIM2, TIM_FLAG_Update);
}

/********************************************************************************************************
**Ϣ void delay_init(void)                         
** ʼӳٺ
** 
** 
**ú 
********************************************************************************************************/
void delay_init(void)
{
    /*ѡⲿʱ  HCLK/8*/
    SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);
    /*Ϊϵͳʱӵ1/8*/    
    fac_us=SystemCoreClock/8000000;				                               
    /*OS,ÿmsҪsystickʱ */
    fac_ms=(u16)fac_us*1000;					                              
}


/********************************************************************************************************
**Ϣ void delay_ms(u16 nms)    
** ʱnms
** nms
** 
**    ע SysTick->LOADΪ24λĴ,,ʱΪ:nms<=0xffffff*8*1000/SYSCLK,72M,nms<=1864 
********************************************************************************************************/
void delay_ms(u16 nms)
{
    u32 temp;
    /*ʱ(SysTick->LOADΪ24bit)*/    
    SysTick->LOAD=(u32)nms*fac_ms;
    /*ռ*/    
    SysTick->VAL =0x00;	
    /*ʼ*/    
    SysTick->CTRL|=SysTick_CTRL_ENABLE_Msk ;	                               
    do{
        temp=SysTick->CTRL;
    }
    /*ȴʱ䵽*/
    while((temp&0x01)&&!(temp&(1<<16)));		                            
    /*رռ*/
    SysTick->CTRL&=~SysTick_CTRL_ENABLE_Msk;	                           
    /*ռ*/    
    SysTick->VAL =0X00;       					                               
}

/********************************************************************************************************
**Ϣ void uart_initwBaudRate(u32 bound)     
** UARTʼ
** bound
** 
**    ע 
********************************************************************************************************/
void uart_initwBaudRate(u32 bound)
{
    /*GPIO˿*/
    GPIO_InitTypeDef GPIO_InitStructure;
    UART_InitTypeDef UART_InitStructure;
    
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
    
    /*UART1_TX   GPIOA.9*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;                                   
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    /**/    
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;		                     
    GPIO_Init(GPIOA, &GPIO_InitStructure);				                        
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_7);
    
    /*UART1_RX  GPIOA.10ʼ*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	                 
    GPIO_Init(GPIOA, &GPIO_InitStructure);				                     
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_7);
    
    /*UART ʼ*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_UART1, ENABLE);	                   

    /*ڲ*/
    UART_InitStructure.UART_BaudRate = bound;
    /*ֳΪ8λݸʽ*/    
    UART_InitStructure.UART_WordLength = UART_WordLength_8b;
    /*һֹͣλ*/    
    UART_InitStructure.UART_StopBits = UART_StopBits_1;
    /*żУλ*/    
    UART_InitStructure.UART_Parity = UART_Parity_No;
    /*Ӳ*/    
    UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None;
    /*շģʽ*/
    UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx;	                
    /*ʼ1*/
    UART_Init(UART1, &UART_InitStructure); 	
    /*ڽж*/    
    UART_ITConfig(UART1, UART_IT_RXIEN, ENABLE);
    /*ʹܴ1*/    
    UART_Cmd(UART1, ENABLE);                    			                    
}

/********************************************************************************************************
**Ϣ void UartSendByte(u8 dat)      
** UART
** dat
** 
**    ע 
********************************************************************************************************/
void UartSendByte(u8 dat)
{
    UART_SendData( UART1, dat);
    while(!UART_GetFlagStatus(UART1,UART_FLAG_TXEPT));
}


/********************************************************************************************************
**Ϣ void UartSendGroup(u8* buf,u16 len)     
** UART
** buf,len
** 
**    ע 
********************************************************************************************************/
void UartSendGroup(u8* buf,u16 len)
{
    while(len--)
        UartSendByte(*buf++);
}

